<template>
  <nuxt-child :keyboard-input="keyboardInput" />
</template>

<script>
export default {
  data() {
    return {
      keyboardInput: {
        left: false,
        right: false,
        jump: false,
        shoot: false,
      },
    };
  },
  mounted() {
    this.inputHandler();
  },
  methods: {
    inputHandler() {
      // get all the keys!!
      document.addEventListener('keydown', this.keydown);
      document.addEventListener('keyup', this.keyup);
    },
    beforeDestroy() {
      document.removeEventListener('keydown', this.keydown);
      document.removeEventListener('keyup', this.keyup);
    },
    keydown(event) {
      if(event.key === 'a') {
          this.keyboardInput.left = true;
      }
      if(event.key === 'd') {
          this.keyboardInput.right = true;
      }
      if(event.key === ' ') {
          this.keyboardInput.jump = true;
      }
    },
    keyup(event) {
      if(event.key === 'a') {
          this.keyboardInput.left = false;
      }
      if(event.key === 'd') {
          this.keyboardInput.right = false;
      }
      if(event.key === ' ') {
          this.keyboardInput.jump = false;
      }
    },
  },
}
</script>

<style lang="scss">
html,
body {
  background: #222;
  width: 100vw;
  height: 100vh;
  overflow: hidden;
  margin: 0;

  #__layout {
    width: 100vw;
    height: 100vh;
    display: flex;
    justify-content: center;
    align-items: center;
  }

  #main {
    position: relative;
    overflow: hidden;
    background: #7feff9;
    background-image: url("/sky.jpg");
    background-blend-mode: lighten;
    background-size: 100%;
    background-repeat: no-repeat;
    border-radius: 6px;
    box-shadow: 0px 0px 41px 18px #7feff966;
  }
}
</style>
